searchData={"items":[{"type":"behaviour","title":"AI","doc":"AI is a behavior module that defines the interface for interacting with\nOpenAI's API. It provides a common interface for the various OpenAI-powered\noperations used by the application.","ref":"AI.html"},{"type":"function","title":"AI.add_user_message/2","doc":"","ref":"AI.html#add_user_message/2"},{"type":"function","title":"AI.create_assistant/1","doc":"","ref":"AI.html#create_assistant/1"},{"type":"function","title":"AI.get_assistant/1","doc":"","ref":"AI.html#get_assistant/1"},{"type":"function","title":"AI.get_embeddings/1","doc":"Get embeddings for the given text. The text is split into chunks of 8192\ntokens to avoid exceeding the model's input limit. Returns a list of\nembeddings for each chunk.","ref":"AI.html#get_embeddings/1"},{"type":"callback","title":"AI.get_embeddings/1","doc":"","ref":"AI.html#c:get_embeddings/1"},{"type":"function","title":"AI.get_messages/2","doc":"","ref":"AI.html#get_messages/2"},{"type":"function","title":"AI.get_summary/2","doc":"Get a summary of the given text. The text is truncated to 128k tokens to\navoid exceeding the model's input limit. Returns a summary of the text.","ref":"AI.html#get_summary/2"},{"type":"callback","title":"AI.get_summary/2","doc":"","ref":"AI.html#c:get_summary/2"},{"type":"function","title":"AI.get_thread_run/2","doc":"","ref":"AI.html#get_thread_run/2"},{"type":"function","title":"AI.run_thread/2","doc":"","ref":"AI.html#run_thread/2"},{"type":"function","title":"AI.split_text/2","doc":"","ref":"AI.html#split_text/2"},{"type":"function","title":"AI.start_thread/0","doc":"","ref":"AI.html#start_thread/0"},{"type":"function","title":"AI.submit_tool_outputs/3","doc":"","ref":"AI.html#submit_tool_outputs/3"},{"type":"function","title":"AI.update_assistant/2","doc":"","ref":"AI.html#update_assistant/2"},{"type":"module","title":"Ask","doc":"","ref":"Ask.html"},{"type":"function","title":"Ask.new/1","doc":"","ref":"Ask.html#new/1"},{"type":"function","title":"Ask.run/1","doc":"","ref":"Ask.html#run/1"},{"type":"module","title":"Assistant","doc":"","ref":"Assistant.html"},{"type":"function","title":"Assistant.get/1","doc":"","ref":"Assistant.html#get/1"},{"type":"module","title":"Fnord","doc":"Fnord is a code search tool that uses OpenAI's embeddings API to index and\nsearch code files.","ref":"Fnord.html"},{"type":"function","title":"Fnord.main/1","doc":"Main entry point for the application. Parses command line arguments and\ndispatches to the appropriate subcommand.","ref":"Fnord.html#main/1"},{"type":"module","title":"Git","doc":"Module for interacting with git.","ref":"Git.html"},{"type":"function","title":"Git.is_ignored?/2","doc":"Check if a file is ignored by git.","ref":"Git.html#is_ignored?/2"},{"type":"module","title":"Indexer","doc":"This module provides the functionality for the `index` and `delete`\nsub-commands.","ref":"Indexer.html"},{"type":"function","title":"Indexer.delete_project/1","doc":"Permanently deletes the project from the store.","ref":"Indexer.html#delete_project/1"},{"type":"function","title":"Indexer.new/2","doc":"Create a new `Indexer` struct.","ref":"Indexer.html#new/2"},{"type":"function","title":"Indexer.run/1","doc":"Run the indexing process using the given `Indexer` struct. If `force_reindex`\nis `true`, the project will be deleted and reindexed from scratch.","ref":"Indexer.html#run/1"},{"type":"module","title":"Queue","doc":"A module that implements a process pool using a GenServer.","ref":"Queue.html"},{"type":"function","title":"Queue.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Queue.html#child_spec/1"},{"type":"function","title":"Queue.init/1","doc":"","ref":"Queue.html#init/1"},{"type":"function","title":"Queue.join/1","doc":"Waits until the queue is empty and all workers have exited.","ref":"Queue.html#join/1"},{"type":"function","title":"Queue.map/2","doc":"Queues an Enum of jobs, executes them, and returns the results in order.","ref":"Queue.html#map/2"},{"type":"function","title":"Queue.queue/2","doc":"Adds a job to the queue and returns a Task.","ref":"Queue.html#queue/2"},{"type":"function","title":"Queue.shutdown/1","doc":"Shuts down the queue, preventing new jobs from being added.","ref":"Queue.html#shutdown/1"},{"type":"function","title":"Queue.start_link/2","doc":"Starts the Queue with the given callback function and maximum number of workers.\nReturns {:ok, pid}","ref":"Queue.html#start_link/2"},{"type":"module","title":"Scanner","doc":"The `Scanner` module traverses a directory recursively, skipping hidden files\nand files that should be ignored based on a `.gitignore` file. It also skips\nbinary files and files with a size of 0 bytes.","ref":"Scanner.html"},{"type":"function","title":"Scanner.count_files/1","doc":"Count the number of files in the directory, excluding hidden, ignored, binary, and empty files.","ref":"Scanner.html#count_files/1"},{"type":"function","title":"Scanner.new/2","doc":"Create a new `Scanner` struct.","ref":"Scanner.html#new/2"},{"type":"function","title":"Scanner.reduce/4","doc":"Recursively scan the directory and accumulate a result using the provided accumulator and function.","ref":"Scanner.html#reduce/4"},{"type":"function","title":"Scanner.scan/2","doc":"Recursively scan the directory and call the callback function for each file.","ref":"Scanner.html#scan/2"},{"type":"module","title":"Search","doc":"This module provides the functionality for the `search` sub-command.","ref":"Search.html"},{"type":"function","title":"Search.cosine_similarity/2","doc":"","ref":"Search.html#cosine_similarity/2"},{"type":"function","title":"Search.get_results/1","doc":"","ref":"Search.html#get_results/1"},{"type":"function","title":"Search.new/2","doc":"Creates a new `Search` struct with the given options.","ref":"Search.html#new/2"},{"type":"function","title":"Search.run/2","doc":"Searches the given project for previously indexed files (see `Indexing`) that\nmatch the given query. The search results are printed to the console.\n\nNote that the query input is first sent to OpenAI's API to generate an\nembedding to match against the vector store.","ref":"Search.html#run/2"},{"type":"module","title":"Settings","doc":"","ref":"Settings.html"},{"type":"function","title":"Settings.get/3","doc":"Get a value from the settings store.","ref":"Settings.html#get/3"},{"type":"function","title":"Settings.home/0","doc":"Get the path to the store root directory.","ref":"Settings.html#home/0"},{"type":"function","title":"Settings.new/0","doc":"","ref":"Settings.html#new/0"},{"type":"function","title":"Settings.set/3","doc":"Set a value in the settings store.","ref":"Settings.html#set/3"},{"type":"function","title":"Settings.settings_file/0","doc":"Get the path to the settings file.","ref":"Settings.html#settings_file/0"},{"type":"module","title":"Spinner","doc":"","ref":"Spinner.html"},{"type":"function","title":"Spinner.run/2","doc":"","ref":"Spinner.html#run/2"},{"type":"module","title":"Store","doc":"This module provides the functionality for storing and retrieving embeddings\nand metadata for files.","ref":"Store.html"},{"type":"function","title":"Store.delete_file/2","doc":"Permanently deletes the specified file from the store. Note that this is\n_only_ exposed for the sake of testing.","ref":"Store.html#delete_file/2"},{"type":"function","title":"Store.delete_missing_files/3","doc":"Permanently delete any files that are indexed but no longer exist on disk.","ref":"Store.html#delete_missing_files/3"},{"type":"function","title":"Store.delete_project/1","doc":"Permanently deletes the specified project's index directory and all its\ncontents.","ref":"Store.html#delete_project/1"},{"type":"function","title":"Store.get/2","doc":"Get the metadata, summary, and embeddings for the specified file. Returns\n`{:ok, info}` if the file exists, or `{:error, :not_found}` if it does not.\n\nThe structure of the returned `info` is as follows:\n\n```\n%{\n  file: \"path/to/file.ext\",\n  hash: \"DEADBEEF\",\n  timestamp: \"2021-01-01T00:00:00Z\",\n  summary: \"AI-generated summary of the file\",\n  embeddings: [\n    [0.1, 0.2, 0.3, ...],\n    [0.4, 0.5, 0.6, ...],\n    ...\n  ]\n}\n```","ref":"Store.html#get/2"},{"type":"function","title":"Store.get_embeddings/2","doc":"Get the embeddings for the specified file. Returns `{:ok, embeddings}` if the\nfile exists, or `{:error, :not_found}` if it does not. Note that if the input\nfile was greater than 8192 tokens, the embeddings will be split into multiple\nchunks.","ref":"Store.html#get_embeddings/2"},{"type":"function","title":"Store.get_hash/2","doc":"Get the hash for the specified file. Returns `{:ok, hash}` if the file\nexists, or `{:error, :not_found}` if it does not.","ref":"Store.html#get_hash/2"},{"type":"function","title":"Store.get_summary/2","doc":"Get the summary for the specified file. Returns `{:ok, summary}` if the file\nexists, or `{:error, :not_found}` if it does not.","ref":"Store.html#get_summary/2"},{"type":"function","title":"Store.info/2","doc":"Get the metadata for the specified file. Returns `{:ok, data}` if the file\nexists, or `{:error, :not_found}` if it does not. The structure of the\nmetadata is as follows:\n\n```\n%{\n  file: \"path/to/file.ext\",\n  hash: \"DEADBEEF\",\n  timestamp: \"2021-01-01T00:00:00Z\",\n  fnord_path: \"path/to/store/FEEBDAED\"\n}\n```","ref":"Store.html#info/2"},{"type":"function","title":"Store.list_files/1","doc":"List all indexed files in the project. Returns a list of absolute, expanded,\nfile paths.","ref":"Store.html#list_files/1"},{"type":"function","title":"Store.list_projects/0","doc":"List all projects in the store. Returns a list of project names.","ref":"Store.html#list_projects/0"},{"type":"function","title":"Store.new/1","doc":"Create a new `Store` struct.","ref":"Store.html#new/1"},{"type":"function","title":"Store.put/5","doc":"Store the metadata, summary, and embeddings for the specified file. If the\nfile already exists in the store, it will be overwritten.","ref":"Store.html#put/5"},{"type":"module","title":"Summary","doc":"This module provides the functionality for the `summary` sub-command.","ref":"Summary.html"},{"type":"function","title":"Summary.run/1","doc":"Run the summary process using the given `project` and `file_path`.","ref":"Summary.html#run/1"},{"type":"extras","title":"Fnord","doc":"# Fnord\n\n[![Tests | Dialyzer](https://github.com/sysread/fnord/actions/workflows/run-tests.yml/badge.svg)](https://github.com/sysread/fnord/actions/workflows/run-tests.yml)\n\nFnord is a command line tool the builds a searchable database of your files,\nusing AI-generated embeddings to index and search your code base, notes, and\nother (non-binary) files.","ref":"readme.html"},{"type":"extras","title":"Installation - Fnord","doc":"1. Install `elixir` if necessary:\n```bash\n# MacOS\nbrew install elixir\n\n# Debian-based\nsudo apt-get install elixir\n```\n\n2. Add the mix escript path to your shell's PATH:\n```bash\necho 'export PATH=\"$HOME/.mix/escripts:$PATH\"' >> ~/.bashrc\nsource ~/.bashrc\n```\n\n3. Install the script:\n```bash\nmix escript.install github sysread/fnord\n```\n\nUse the same command to reinstall. It will offer to overwrite the existing\ninstallation.","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Fnord","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Index - Fnord","doc":"The first time you run this, especially on a large codebase, it will take a\nwhile to index everything. Subsequent runs will be faster, re-indexing only\nthose files which have changed since they were last indexed.\n\n```bash\nfnord index --project foo --dir /path/to/foo\n```\n\nYou can **reindex** the project, forcing it to reindex all files:\n\n```bash\nfnord index --project foo --dir /path/to/foo --reindex\n```\n\nYou can also watch the project for changes and reindex them as they happen\nusing [watchman](https://github.com/facebook/watchman). Just be sure to use\n`--quiet` to suppress interactive output:\n\n```bash\nwatchman-make -p '**/*' --settle 5 --run \"fnord index --project $project --dir $project_root --quiet\"\n```\n\n...or use the `fnord-watch` script in the [tools directory on\nGitHub](https://github.com/sysread/fnord/blob/main/tools/fnord-watch).\n\n```bash\nfnord-watch -p foo -d /path/to/foo\n```","ref":"readme.html#index"},{"type":"extras","title":"Search - Fnord","doc":"```bash\nfnord search --project foo --query \"some search query\"\n```\n\nIf you want more detail about each file matched:\n\n```bash\nfnord search --project foo --query \"some search query\" --detail\n```","ref":"readme.html#search"},{"type":"extras","title":"Ask - Fnord","doc":"You can ask the AI assistant to answer questions about your project:\n\n```bash\nfnord ask foo \"how do you run the tests for this project?\"\n\n# Continue the conversation\nfnord ask -C foo \"how does the test coverage look to you?\"\n\n# With status messages emitted to stderr\nfnord ask -C --debug foo \"if the test coverage is so amazing then how come my change didn't break any tests?!\"\n\n# Pipe output to `glow` to render markdown\nfnord ask foo \"summarize the dependencies of this project\" | glow\n```","ref":"readme.html#ask"},{"type":"extras","title":"Miscellaneous - Fnord","doc":"- **List projects:** `fnord projects`\n- **List files in a project:** `fnord files --project foo`\n- **Show the AI-generated summary of a file:** `fnord summary --project foo --file bar`\n- **Delete a project:** `fnord delete --project foo`\n\nNote that deleting a project only deletes from the index, not the actual files.","ref":"readme.html#miscellaneous"},{"type":"extras","title":"TODO - Fnord","doc":"- `ask`: read questions from stdin\n- `ask`: streaming output","ref":"readme.html#todo"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}